"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AzureFunctionTriggerAdapter = exports.AzureFunctionTriggerAdapterStatic = exports.createHandlerAdapter = void 0;
const azure_function_explorer_1 = require("./azure-function-explorer");
let handler;
function createHandlerAdapter(app) {
    return (context) => __awaiter(this, void 0, void 0, function* () {
        yield azure_function_explorer_1.AzureFunctionExplorer.dispatchFunctionTrigger(app, context);
    });
}
exports.createHandlerAdapter = createHandlerAdapter;
class AzureFunctionTriggerAdapterStatic {
    handle(createApp, context) {
        if (handler) {
            return handler(context);
        }
        return this.createHandler(createApp).then((fn) => fn(context));
    }
    createHandler(createApp) {
        return __awaiter(this, void 0, void 0, function* () {
            const app = yield createApp();
            handler = createHandlerAdapter(app);
            return handler;
        });
    }
}
exports.AzureFunctionTriggerAdapterStatic = AzureFunctionTriggerAdapterStatic;
exports.AzureFunctionTriggerAdapter = new AzureFunctionTriggerAdapterStatic();
